io.vertx.ext.web.handler.sockjs

## Interface SockJSSocket

- All Superinterfaces:
    ReadStream<Buffer>, StreamBase, WriteStream<Buffer>

      public interface SockJSSocket
      extends ReadStream<Buffer>, WriteStream<Buffer>

  You interact with SockJS clients through instances of SockJS socket.

  The API is very similar to `WebSocket`. It implements both `ReadStream` and `WriteStream` so it can be used with `Pump` to pump data with flow control.

  Author:
    Tim Fox

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Close it
    `SockJSSocket` | `drainHandler(Handler<Void> handler)` Set a drain handler on the stream.
    `void` | `end()` Call `end()`.
    `SockJSSocket` | `endHandler(Handler<Void> endHandler)` Set an end handler.
    `SockJSSocket` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the read stream.
    `SockJSSocket` | `handler(Handler<Buffer> handler)` Set a data handler.
    `MultiMap` | `headers()` Return the headers corresponding to the last request for this socket or the websocket handshake Any cookie headers will be removed for security reasons
    `SocketAddress` | `localAddress()` Return the local address for this socket
    `SockJSSocket` | `pause()` Pause the `ReadSupport`.
    `SocketAddress` | `remoteAddress()` Return the remote address for this socket
    `SockJSSocket` | `resume()` Resume reading.
    `SockJSSocket` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
    `String` | `uri()` Return the URI corresponding to the last request for this socket or the websocket handshake
    `Session` | `webSession()`
    `User` | `webUser()`
    `SockJSSocket` | `write(Buffer data)` Write some data to the stream.
    `default SockJSSocket` | `write(String data)` Write a `String` to the socket, encoded in UTF-8.
    `String` | `writeHandlerID()` When a `SockJSSocket` is created it automatically registers an event handler with the event bus, the ID of that handler is given by `writeHandlerID`.

    - ### Methods inherited from interface io.vertx.core.streams.WriteStream

      `end, writeQueueFull`

- - ### Method Detail

    - #### exceptionHandler

          SockJSSocket exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### handler

          SockJSSocket handler(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          SockJSSocket pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadSupport`. While it's paused, no data will be sent to the `dataHandler`
      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          SockJSSocket resume()

      Description copied from interface: `ReadStream`
      Resume reading. If the `ReadSupport` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          SockJSSocket endHandler(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### write

          SockJSSocket write(Buffer data)

      Description copied from interface: `WriteStream`
      Write some data to the stream. The data is put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a `Pump`.
      Specified by:
        `write` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### write

          default SockJSSocket write(String data)

      Write a `String` to the socket, encoded in UTF-8.
      Parameters:
        `data` - the string to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          SockJSSocket setWriteQueueMaxSize(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pump` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, the number of `Message` for a `MessageProducer`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          SockJSSocket drainHandler(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pump` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.
      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeHandlerID

          String writeHandlerID()

      When a `SockJSSocket` is created it automatically registers an event handler with the event bus, the ID of that handler is given by `writeHandlerID`.

      Given this ID, a different event loop can send a buffer to that event handler using the event bus and that buffer will be received by this instance in its own event loop and written to the underlying socket. This allows you to write data to other sockets which are owned by different event loops.

    - #### end

          void end()

      Call `end()`.
      Specified by:
        `end` in interface `WriteStream<Buffer>`

    - #### close

          void close()

      Close it

    - #### remoteAddress

          SocketAddress remoteAddress()

      Return the remote address for this socket

    - #### localAddress

          SocketAddress localAddress()

      Return the local address for this socket

    - #### headers

          MultiMap headers()

      Return the headers corresponding to the last request for this socket or the websocket handshake Any cookie headers will be removed for security reasons

    - #### uri

          String uri()

      Return the URI corresponding to the last request for this socket or the websocket handshake

    - #### webSession

          Session webSession()

      Returns:
        the Vert.x-Web session corresponding to this socket

    - #### webUser

          User webUser()

      Returns:
        the Vert.x-Web user corresponding to this socket

Copyright © 2018 Eclipse. All rights reserved.